package Project;

import java.awt.*;

import java.awt.event.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.*;

/**
 * This panel is the starting screen for the program that will display the names of the children. 
 *
 *
 */

public class NamesPanel extends JPanel implements ActionListener{
	
	private static final long serialVersionUID = 1L;
		private Programma mainWindow;
		Image img;
		JPanel nameP;
		static String fileName = "Names.txt";
		String[] names;
		JButton[] buttons;
		int size;
		JLabel description1, description2;
		JTextField name, remname;
		JButton addName, removeName;
		int buttonsize, width, height;
		
		public NamesPanel(Programma mainWindow)  {
			img = new ImageIcon(Programma.class.getResource("/background.PNG")).getImage();
			
			//read in the names from the document names.txt and add them to the list names
			String line=null;		
			try {
				if (!(new File(fileName)).exists()) { //if the Names.txt file doesn't exist, one should be made
					File file = new File(fileName);
					file.createNewFile();
				}
	            FileReader fileReader = new FileReader(fileName);
	            BufferedReader bufferedReader = new BufferedReader(fileReader);
	            
	            names = new String[100];
	            size=0;
	            int i=0;
	            while((line = bufferedReader.readLine()) != null) {
	            	size+=1;
	            	names[i] = line;
	            	System.out.println(line);
	            	i+=1;
	            }
	            
	            bufferedReader.close();  
	            fileReader.close();
	        }
	        catch(FileNotFoundException ex) {
	            System.out.println(
	                "Unable to open file '" + fileName + "'");                
	        }
	        catch(IOException ex) {
	            System.out.println(
	                "Error reading file '"  + fileName + "'");
	        }
			
			//configure the layout of the panel
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			width = screenSize.width;
			height = screenSize.height;

			this.setLayout(null);
			this.mainWindow = mainWindow;
			nameP = this;
			
			//Make a JButton for every name in the Names.txt document and place it on the panel
			buttonsize = 200;
			buttons = new JButton[names.length];

			for (int j=0;j<size;j++) {
				buttons[j] = new JButton(names[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				buttons[j].setBounds(width/size*j+100,height/2-buttonsize,buttonsize,buttonsize);
				this.add(buttons[j]);
			}
			
			//add JLabels, JButtons and JTextfields to be able to add a name or remove a name from the list
	        description1 = new JLabel();
	        name = new JTextField();
	        addName = new JButton();
	        
	        description1.setText("Add name: ");
	        description1.setBounds(10, height-300, 100, 20);
	        
	        name.setBounds(100, height - 300, 200, 20);
	        this.add(name);

	        addName.setText("Submit");
	        addName.setBounds(300, height-300, 100, 20);
	        addName.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	            	String newName = name.getText(); //get user input from JTextfield
	            	System.out.println(newName);
	            	BufferedWriter bw = null;
	        		FileWriter fw = null;

	        		try {
	        			fw = new FileWriter(fileName);
	        			bw = new BufferedWriter(fw);
	        			for (int j=0;j<size;j++) {
	        				bw.write(names[j]);
	        				bw.newLine();
	        			}
	        			bw.write(newName);
	        			names[size] = newName;
	        			size +=1;
	        			
	        		} catch (IOException e) {

	        			e.printStackTrace();
	        			
	        		} finally {
	        			try {
	        				if (bw != null)
	        					bw.close();
	        				if (fw != null)
	        					fw.close();
	        			} catch (IOException ex) {
	        				ex.printStackTrace();
	        			}
	        		}
	        		addButtons();
	            }
	        });
	        
	        this.add(addName);
	        this.add(description1);
	        

	        description2 = new JLabel();
	        remname = new JTextField();
	        removeName = new JButton();
		
	        description2.setText("Remove name: ");
	        description2.setBounds(10, height-200, 100, 20);
	        
	        remname.setBounds(100, height - 200, 200, 20);
	        this.add(remname);

	        removeName.setText("Delete");
	        removeName.setBounds(300, height-200, 100, 20);
	        removeName.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String name2remove = remname.getText();
					int skip = size+1;
	            	System.out.println(name2remove);
	            	for (int j=0;j<size;j++) {
        				if(names[j].equals(name2remove)) {
        					skip = j;
        					size-=1;
        				}
        				
        			}
	            	System.out.println(skip);
	            	
	            	BufferedWriter bw = null;
	        		FileWriter fw = null;
	        		
	        		//reorganiseList is used to move the names in the list when one of the names is deleted, so the deleted name doesn't occur in the nameslist anymore
	        		int reorganiseList = 0;
	        		try {
	        			fw = new FileWriter(fileName);
	        			bw = new BufferedWriter(fw);
	        			for (int j=0;j<size+1;j++) {
	        				if(j!=skip) {
	        				bw.write(names[j]);
	        				bw.newLine();
	        				names[j-reorganiseList] = names[j]; //to delete name out of the list
	        				}
	        				else {
	        					reorganiseList = 1;
	        				}
	        			}
	        			
	        			
	        		} catch (IOException e1) {

	        			e1.printStackTrace();
	        			
	        		} finally {
	        			try {
	        				if (bw != null)
	        					bw.close();
	        				if (fw != null)
	        					fw.close();
	        			} catch (IOException ex) {
	        				ex.printStackTrace();
	        			}
	        		}
	            	removeButtons();
	            	
				}
	        	
	        });
			
	        this.add(description2);
	        this.add(removeName);
	        
			validate();

		}
		
		public void paintComponent(Graphics g) {
			super.paintComponent(g);

			g.drawImage(img, 0, 0, this.getWidth(), this.getHeight(), this);
		}

		
		public void actionPerformed(ActionEvent ae)
		{
			//if one of the buttons is pressed, we need to switch to the next panel
			for (int i=0;i < size; i++) {
				if(ae.getSource() == buttons[i]) {
					OptionPanel  optionpanel1 = new OptionPanel(mainWindow, nameP, names[i]);
					mainWindow.switchPanel(optionpanel1);
				}
					
			}
	}
		
		//when a new name is added, the old buttons should be removed and the new buttons with the new name should be added
		public void addButtons() {
			for (int j=0;j<size-1;j++) {
				this.remove(buttons[j]);
			}
			this.revalidate();
    		this.repaint();
			
			for (int j=0;j<size;j++) {
				buttons[j] = new JButton(names[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				buttons[j].setBounds(width/size*j+100,height/2-buttonsize,buttonsize,buttonsize);
				this.add(buttons[j]);
			}
		}
		
		//when a name is deleted, the old buttons should be removed as to remove the button with the name that is now deleted
		public void removeButtons() {
			for (int j=0;j<size+1;j++) {
				this.remove(buttons[j]);
			}
			this.revalidate();
    		this.repaint();
			
			for (int j=0;j<size;j++) {
				buttons[j] = new JButton(names[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				buttons[j].setBounds(width/size*j+100,height/2-buttonsize,buttonsize,buttonsize);
				this.add(buttons[j]);
			}
		}

}