package Project;

import java.awt.*;

import java.awt.event.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.*;

public class OptionPanel extends JPanel implements ActionListener{
	
	/**
	 * in this panel the category is chosen for which pictures should be shown
	 * 
	 */
	private static final long serialVersionUID = 1L;
		private Programma mainVenster;
		Image img;
		JPanel nameP;
		static String fileName = "Categories.txt";
		String[] categories;
		JButton[] buttons;
		int size;
		JButton backButton;
		JLabel text;
		int width, height, buttonsize;
		
		JLabel description1, description2;
		JTextField category, remcategory;
		JButton addCategory, removeCategory;
		
		String nameSelected;
		
		public OptionPanel(Programma mainVenster, JPanel namePanel, String name)  {
			
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			width = screenSize.width;
			height = screenSize.height;
			
			nameSelected = name;
			
			String line=null;
			nameP = namePanel;
			
			backButton = new JButton("Back");
			backButton.addActionListener(this);
			backButton.setFont(new Font("Arial", Font.PLAIN, 20));
			backButton.setBounds(width/2, 0, 100, 20);
			
			
			try {
				if (!(new File(fileName)).exists()) { //if the categories.txt file doesn't exist, one should be made
					File file = new File(fileName);
					file.createNewFile();
				}
	            FileReader fileReader = new FileReader(fileName);

	            BufferedReader bufferedReader = new BufferedReader(fileReader);
	            
	            categories = new String[100];
	            size=0;
	            int i=0;
	            while((line = bufferedReader.readLine()) != null) {
	            	size+=1;
	            	categories[i] = line;
	            	System.out.println(line);
	            	i+=1;
	            }
	            
	            bufferedReader.close();  
	            fileReader.close();
	        }
	        catch(FileNotFoundException ex) {
	            System.out.println(
	                "Unable to open file '" + fileName + "'");                
	        }
	        catch(IOException ex) {
	            System.out.println(
	                "Error reading file '"  + fileName + "'");
	        }
			
			buttonsize = 200;
			
			this.setLayout(null);
			
			this.mainVenster = mainVenster;
			nameP = this;
			buttons = new JButton[categories.length];
			for (int j=0;j<size;j++) {
				buttons[j] = new JButton(categories[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].setBounds(width/(size+1)*(j+1)-buttonsize/2, height/2-buttonsize, buttonsize, buttonsize);
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				this.add(buttons[j]);
			}
			
			this.add(backButton);
			description1 = new JLabel();
	        category = new JTextField();
	        addCategory = new JButton();
	        

	        description1.setText("Add category: ");
	        description1.setBounds(10, height-300, 100, 20);
	        
	        category.setBounds(100, height - 300, 200, 20);
	        this.add(category);

	        addCategory.setText("Submit");
	        addCategory.setBounds(300, height-300, 100, 20);
	        addCategory.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	            	String newName = category.getText();
	            	System.out.println(newName);
	            	BufferedWriter bw = null;
	        		FileWriter fw = null;

	        		try {
	        			fw = new FileWriter(fileName);
	        			bw = new BufferedWriter(fw);
	        			for (int j=0;j<size;j++) {
	        				bw.write(categories[j]);
	        				bw.newLine();
	        			}
	        			bw.write(newName);
	        			categories[size] = newName;
	        			size +=1;
	        			
	        		} catch (IOException e) {

	        			e.printStackTrace();
	        			
	        		} finally {
	        			try {
	        				if (bw != null)
	        					bw.close();
	        				if (fw != null)
	        					fw.close();
	        			} catch (IOException ex) {
	        				ex.printStackTrace();
	        			}
	        		}
	        		addButtons();
	            }
	        });
	        
	        this.add(addCategory);
	        this.add(description1);
	        

	        description2 = new JLabel();
	        remcategory = new JTextField();
	        removeCategory = new JButton();
		
	        description2.setText("Remove name: ");
	        description2.setBounds(10, height - 200, 100, 20);
	        
	        remcategory.setBounds(100, height - 200, 200, 20);
	        this.add(remcategory);

	        removeCategory.setText("Delete");
	        removeCategory.setBounds(300, height-200, 100, 20);
	        removeCategory.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String name2remove = remcategory.getText();
					int skip = size+1;
					boolean removing = false;
	            	System.out.println(name2remove);
	            	for (int j=0;j<size;j++) {
        				if(categories[j].equals(name2remove)) {
        					if(!categories[j].equals("Music")) {
        						skip =j;
        						size-=1;
        						removing = true;
        					}
        					else {
        						skip = size+1;
        						System.out.println("Category was music");
        						
        					}
        					
        				}
        			}
	            	System.out.println(skip);
	            	
	            	BufferedWriter bw = null;
	        		FileWriter fw = null;
	        		
	        		if (removing) {
	        		int reorganiseList = 0;
	        		try {
	        			fw = new FileWriter(fileName);
	        			bw = new BufferedWriter(fw);
	        			for (int j=0;j<size+1;j++) {
	        				if(j!=skip) {
	        				bw.write(categories[j]);
	        				bw.newLine();
	        				categories[j-reorganiseList] = categories[j]; //to delete name out of the list
	        				}
	        				else {
	        					reorganiseList = 1;
	        				}
	        			}
	        			
	        		} catch (IOException e1) {

	        			e1.printStackTrace();
	        			
	        		} finally {
	        			try {
	        				if (bw != null)
	        					bw.close();
	        				if (fw != null)
	        					fw.close();
	        			} catch (IOException ex) {
	        				ex.printStackTrace();
	        			}
	        		}
	            	removeButtons();
	        		}
				}
	        	
	        });
			
	        this.add(description2);
	        this.add(removeCategory);
	        
			
			validate();

		}
		
		public void paintComponent(Graphics g) {
			super.paintComponent(g);

			g.drawImage(img, 0, 0, this.getWidth(), this.getHeight(), this);
		}

		
		public void actionPerformed(ActionEvent ae)
		{
			for (int i=0;i < size; i++) {
				if(ae.getSource() == buttons[i]) {
					ProgramPanel  panel1 = new ProgramPanel(mainVenster, nameP,categories[i],nameSelected);
					mainVenster.switchPanel(panel1);
				}
					
			}
			
			if (ae.getSource()==backButton){
				mainVenster.switchPanel();
			}

	}
		
		public void addButtons() {
			
			for (int j=0;j<size-1;j++) {
				this.remove(buttons[j]);
			}
			this.revalidate();
    		this.repaint();
			
			for (int j=0;j<size;j++) {
				buttons[j] = new JButton(categories[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].setBounds(width/(size+1)*(j+1)-buttonsize/2, height/2-buttonsize/2, buttonsize, buttonsize);
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				this.add(buttons[j]);
			}
		}
		
		public void removeButtons() {
			for (int j=0;j<size+1;j++) {
				this.remove(buttons[j]);
			}
			this.revalidate();
    		this.repaint();
			
    		for (int j=0;j<size;j++) {
				buttons[j] = new JButton(categories[j]);
				buttons[j].setFont(new Font("Arial", Font.PLAIN, 40));
				buttons[j].setBounds(width/(size+1)*(j+1)-buttonsize/2, height/2-buttonsize, buttonsize, buttonsize);
				buttons[j].addActionListener(this);
				buttons[j].setBackground(Color.orange);
				this.add(buttons[j]);
			}
		}

}