package Project;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
//import java.net.URL;
import java.nio.file.FileSystems;
import java.nio.file.Files;
//import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardCopyOption;
//import java.nio.file.StandardCopyOption;
import java.util.ArrayList;

import javax.print.attribute.standard.Media;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

//import java.awt.Component;

/*from   w w w. j a  v a  2 s  .c om*/
//import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;

//import javax.swing.JScrollPane;
//import javax.swing.ListCellRenderer;
//import javax.swing.ListSelectionModel;
import javax.swing.Timer;

public class ProgramPanel extends JPanel implements ActionListener{
	
	/**
	 * the panel where the images appear and there is interaction with the remote 
	 */
	private static final long serialVersionUID = 1L;
	Image BlueArrow = new ImageIcon(Programma.class.getResource("/bluearrow2.png")).getImage();
	Image RedArrow = new ImageIcon(Programma.class.getResource("/redarrow.png")).getImage();
	
	Timer switchPicture = new Timer(200,this);
	
	private int picture =0;
	
	private Programma mainWindow;
	
	String fileID;
	
	private JButton left,right, backButton, addFile, deleteFile, confirmButton;
	
	File folder;
	File[] listOfFiles;
	
	Image img, confirmPicture;
	File f = null; // to read images from certain file
	
	JPanel panel;
	
	String category, picture2delete, songname, name;
	
	String buttonsRead=null; //output from buttons
	
	MyRunnable connection;
	
	int time = 0;
	
	boolean switching = false;
	
	int commandNumber = 0;
	
	boolean confirmed;
	
	Thread wifi;
	
	int fileLength;
	
	Sound song;
	
	
	public ProgramPanel(Programma mainWindow, JPanel menu, String category, String name) {
		this.mainWindow = mainWindow;
		panel=menu;
		this.category=category;
		this.name = name;
		//create folders when they don't exist
		if (!(new File("src/main/resources/" + name + "/"+ category)).exists()) { 
			File file = new File("src/main/resources/"  + name + "/"+ category);
			file.mkdirs();
		}
		
		folder = new File("src/main/resources/" + name + "/"+ category);
		listOfFiles = folder.listFiles();
		System.out.println("category is "+category);
		System.out.println(listOfFiles);
		
		//if the folder isn't empty, read in the first image
		if (folder.list().length>0){
			fileLength = listOfFiles.length;
			img = new ImageIcon("src/main/resources/" + name + "/"+category + "/" + listOfFiles[0].getName()).getImage();
		}
		
	    for (File file : listOfFiles) {
	      System.out.println(file.getName());
	    }
	    
	    //start the timer
		switchPicture.restart();
		
		confirmed = false;
		
		// buttons to test the program
		left = new JButton("Left");
		left.addActionListener(this);
		right = new JButton("Right");
		right.addActionListener(this);
		confirmButton = new JButton("Confirm");
		confirmButton.addActionListener(this);
		
		backButton = new JButton("Back");
		backButton.addActionListener(this);
		addFile = new JButton("Add File");
		addFile.addActionListener(this);
		deleteFile = new JButton("Delete File");
		deleteFile.addActionListener(this);
		
		this.add(left);
		this.add(right);
		this.add(confirmButton);
		this.add(backButton);
		this.add(addFile);
		this.add(deleteFile);

		
		//start a new thread to read the incoming information via wifi
		connection  = new MyRunnable();
		wifi = new Thread(connection);
		wifi.start();
	}
	
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		int size = 400;
		int extra = 200; //bigger size for picture that appears when choice is confirmed
		g.drawImage(confirmPicture, this.getWidth()/2-size/2-3-4*extra/2-50, this.getHeight()/2-size/2-extra/2, size+4*extra+100, size+extra, this);
		g.drawImage(img, this.getWidth()/2-size/2-50, this.getHeight()/2-size/2, size+100, size, this);
		int arrowsize = 200;
		g.drawImage(BlueArrow, this.getWidth()/4-arrowsize/2, this.getHeight()/2-arrowsize/2, arrowsize, arrowsize, this);
		g.drawImage(RedArrow, this.getWidth()*3/4-arrowsize/2, this.getHeight()/2-arrowsize/2, arrowsize, arrowsize, this);
		
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource() == left){
			
			if (!confirmed) {
					picture-=1;
					// To scroll through the list when we get to the end of it
					if (picture<0) {
						picture=listOfFiles.length-1;
					}
					
					if (listOfFiles[picture].getName().equals("Songs")) { //to skip the map that contains the songs in the list of files
					picture-=1;	
					}
					
					if (picture<0) {
						picture=listOfFiles.length-1;
					}
							
			img = new ImageIcon("src/main/resources/" + name + "/"+category + "/" + listOfFiles[picture].getName()).getImage();
			this.repaint();
			System.out.println(Integer.toString(picture));
			}
		}
		
		else if (ae.getSource()==right){
			if (!confirmed) {
				picture+=1;
				
				if (picture>listOfFiles.length-1) {
					picture=0;
				}
				
			if (listOfFiles[picture].getName().equals("Songs")) {
					picture+=1;	
				}
				
			// To scroll through the list when we get to the end of it
				if (picture>listOfFiles.length-1) {
					picture=0;
				}
			
				
			img = new ImageIcon("src/main/resources/"+ name + "/" +category + "/" + listOfFiles[picture].getName()).getImage();
			this.repaint();
			System.out.println(Integer.toString(picture));
			}
		}
		
		else if (ae.getSource()==backButton){
			//Stop the timer
			switchPicture.stop();
			
			//Stop the thread to connect to wifi
			wifi.interrupt();
			connection.closeClient();
			
			//switch to previous panel
			mainWindow.switchPanel(panel);
			
		}
		
		
		else if (ae.getSource()==addFile){ //source: https://stackoverflow.com/questions/36324184/trying-to-move-file-to-different-locationin-project-folder
			JFileChooser chooser= new JFileChooser();
			String imagename = null;
			chooser.setDialogTitle("Select Image");
			int result = chooser.showOpenDialog(null);        
	        
	        if (result == JFileChooser.APPROVE_OPTION) {
	            File file = chooser.getSelectedFile();
	            
	            String sname = file.getAbsolutePath(); 
	            imagename = file.getName();
	            
	            System.out.println(sname);
	            
	            Path movefrom = FileSystems.getDefault().getPath(file.getPath());
	            System.out.println("move form:" + movefrom);
	            final String dir = System.getProperty("user.dir"); //source: https://stackoverflow.com/questions/3153337/get-current-working-directory-in-java
	            System.out.println("current directory = " + dir);
	           
	                	
	                	//move the file
	                Path target = FileSystems.getDefault().getPath(dir+ '/' + "src/main/resources/" + name + "/"+ category + '/' +file.getName());
	                System.out.println("target :"+ target);
	                try{
	                	//Files.move(movefrom,target,StandardCopyOption.ATOMIC_MOVE);
	                	Files.copy(movefrom, target, StandardCopyOption.COPY_ATTRIBUTES);
			            System.out.println("File is moved");
			       }catch (IOException e){}

	                
		}
	        
	        if (category.equals("Music")) { //if the category is music, the mp3 file for the song also needs to be added
            	JFileChooser chooser2= new JFileChooser();
    			
    			chooser2.setDialogTitle("Select Song");
    			int result2 = chooser2.showOpenDialog(null);        
    	        
    	        if (result2 == JFileChooser.APPROVE_OPTION) {
    	            File song = chooser2.getSelectedFile();
    	            
    	            String songpath = song.getAbsolutePath(); 
    	            
    	            songname = song.getName();
    	            
    	             String imageWithoutExtension  = imagename.replaceFirst("[.][^.]+$", "");
    	             System.out.println(imageWithoutExtension);

    	            System.out.println(songpath);
    	            
    	            Path movefrom2 = FileSystems.getDefault().getPath(song.getPath());
    	            System.out.println("move form 2:" + movefrom2);
    	            final String dir2 = System.getProperty("user.dir"); //source: https://stackoverflow.com/questions/3153337/get-current-working-directory-in-java
    	            System.out.println("current directory = " + dir2);
    	            if (!(new File("src/main/resources/" + name + "/"+ category + "/Songs")).exists()) { 
    	    			File file = new File("src/main/resources/"  + name + "/"+ category + "/Songs");
    	    			file.mkdirs();
    	    		}
    	    		
    	                	
    	                	//move the file
    	                Path target2 = FileSystems.getDefault().getPath(dir2+'/'+ "src/main/resources/" + name + '/' + category + "/Songs/" + imageWithoutExtension + ".mp3" );
    	                System.out.println("target2 :"+ target2);
    	                try{
    	                	Files.copy(movefrom2,target2,StandardCopyOption.COPY_ATTRIBUTES);
    			            System.out.println("File song is moved");
    			       }catch (IOException e){}
            }
            }
	        listOfFiles = folder.listFiles();
	        fileLength = listOfFiles.length;
    }
		
		
		else if (ae.getSource() == switchPicture) { // for every tick of the timer
			ArrayList<String> commands = connection.outputArray();
			System.out.println("commands = " + commands);
			
			if (commandNumber<commands.size()) {
			if (commands.get(commandNumber)!=null) {
				String buttonRead = commands.get(commandNumber);
			
			if (buttonRead.equals("r")) { //right button
				if (!confirmed) {
					picture+=1;
					
					if (picture>listOfFiles.length-1) {
						picture=0;
					}
					
				if (listOfFiles[picture].getName().equals("Songs")) {
						picture+=1;	
					}
					
				// To scroll through the list when we get to the end of it
					if (picture>listOfFiles.length-1) {
						picture=0;
					}
				
					
				img = new ImageIcon("/src/main/resources/" + name + "/" +category + "/" + listOfFiles[picture].getName()).getImage();
				this.repaint();
				System.out.println(Integer.toString(picture));
				}
				
			}
			
			else if (buttonRead.equals("l")) { //left button
				if (!confirmed) {
					picture-=1;
					// To scroll through the list when we get to the end of it
					if (picture<0) {
						picture=listOfFiles.length-1;
					}
					
					if (listOfFiles[picture].getName().equals("Songs")) { //to skip the map that contains the songs in the list of files
					picture-=1;	
					}
					
					if (picture<0) {
						picture=listOfFiles.length-1;
					}
							
					img = new ImageIcon("/src/main/resources/" + name + "/"+category + "/" + listOfFiles[picture].getName()).getImage();
					this.repaint();
					System.out.println("left " + buttonRead);
				}
			}
			
			else if (buttonRead.equals("m")) { //middle button (to confirm)
				if (!confirmed) {
					confirmPicture = new ImageIcon(Programma.class.getResource("/confirm.png")).getImage();
					confirmed = true;
					
					if (category.equals("Music")) {
						System.out.println("Music should play");
						final String dir = System.getProperty("user.dir");
						String imagename = listOfFiles[picture].getName().replaceFirst("[.][^.]+$", "");
						String fileName = new String(dir + "/src/main/resources/" + name + '/' + category +"/Songs/" + imagename + ".mp3");
						//create seperate thread to play music
						song = new Sound(fileName); 
						Thread playing = new Thread(song);
						playing.start();
					}
					
				}
				
				else if (confirmed){ // the second time the confirm button is pressed, the image needs to be deselected
					confirmPicture = new ImageIcon("").getImage();
					confirmed = false;
					
					if (category.equals("Music")) {
						System.out.println("Music should stop playing");
						song.stopMusic();
					}
				}
				
				this.repaint();

			}
				
			
				
			else { //if the command received over wifi isn't "r", "l" or "m"
				System.out.println("doesn't correspond to command");
			}
			commandNumber+=1;
			
			}
			
		}
		}
			
		
		else if (ae.getSource()==deleteFile){
			
			JLabel message = new JLabel("Please select the files to remove: ");
            JFrame frame = new JFrame();
            frame.getContentPane().add(message);
            frame.repaint();
            
            //source: https://stackoverflow.com/questions/19766/how-do-i-make-a-list-with-checkboxes-in-java-swing
            CheckListItem[] checklist = new CheckListItem[fileLength];
            for (int i = 0;i<fileLength;i++) {
            	if (!listOfFiles[i].getName().equals("Songs")) { //the map "Songs" can not be deleted
            		checklist[i] = (new CheckListItem(listOfFiles[i].getName()));
            	}

            }
            JList list = new JList(checklist);
                list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                list.addMouseListener(new MouseAdapter() {
                  @Override
                  public void mouseClicked(MouseEvent event) {
                    JList list = (JList) event.getSource();
                    int index = list.locationToIndex(event.getPoint());// Get index of item
                                                                       // clicked
                    CheckListItem item = (CheckListItem) list.getModel()
                        .getElementAt(index);
                    System.out.println(item);
                    System.out.println(!item.isSelected());
                    item.setSelected(!item.isSelected()); // Toggle selected state
                    list.repaint(list.getCellBounds(index, index));// Repaint cell
                    
                    if (item.isSelected()==true){
                	picture2delete = item.toString();
                	System.out.println(picture2delete);
                	
                	//delete the file
                	final String dir = System.getProperty("user.dir"); 
                	Path target = FileSystems.getDefault().getPath(dir+'/' + "src/main/resources/" + name + "/" +category + '/' +picture2delete);
                	System.out.println("target :"+ target);
                	try{
		               Files.delete(target);
		               if (category.equals("Music")) { //to also delete the mp3 file
		            	   Files.delete(FileSystems.getDefault().getPath(dir+'/' + "src/main/resources/" + name + "/" +category + "/Songs/" +picture2delete.replaceFirst("[.][^.]+$", "") + ".mp3"));
		               }
		               listOfFiles = folder.listFiles();
		               fileLength = listOfFiles.length;
		                System.out.println("File is removed");
		                frame.dispatchEvent(new WindowEvent(frame, WindowEvent.WINDOW_CLOSING));
		            }catch (IOException e){}               	
                	
                }
                  }
                });
                frame.getContentPane().add(new JScrollPane(list));
                frame.pack();
                frame.setVisible(true);
                
                
                
			
		}
		
		else if (ae.getSource()==confirmButton){
			if (!confirmed) {
				confirmPicture = new ImageIcon(Programma.class.getResource("/confirm.png")).getImage();
				confirmed = true;
				
				if (category.equals("Music")) {
					System.out.println("Music should play");
					final String dir = System.getProperty("user.dir");
					String imagename = listOfFiles[picture].getName().replaceFirst("[.][^.]+$", "");
					String fileName = new String(dir + "/src/main/resources/" + name + '/' + category +"/Songs/" + imagename + ".mp3");
					song = new Sound(fileName);
					Thread playing = new Thread(song);
					playing.start();
				}
				
			}
			
			else if (confirmed){
				confirmPicture = new ImageIcon("").getImage();
				confirmed = false;
				
				if (category.equals("Music")) {
					System.out.println("Music should stop playing");
					song.stopMusic();
				}
			}
			
			this.repaint();

		}
	}
}

